﻿using Syncfusion.Windows.PropertyGrid;
using Syncfusion.Windows.Shared;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace CustomPropertyEditor
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            pgrid.SelectedObject = new Details();
            this.DataContext = this;
            CustomEditor comboeditor = new CustomEditor() { HasPropertyType = true, PropertyType = typeof(IList<int>), Editor = new ComboEditor() };
            pgrid.CustomEditorCollection.Add(comboeditor);

            CustomEditor combostringeditor = new CustomEditor() { HasPropertyType = true, PropertyType = typeof(IList<string>), Editor = new ComboStringEditor() };
            pgrid.CustomEditorCollection.Add(combostringeditor);
            pgrid.RefreshPropertygrid();
        }
    }

   
    public class Details
    {
        public Details()
        {
            Unit = 1.00;
            Mark = 65.00;
            Average = 30.00;
            Name.Add("John");
            Name.Add("Steve");
            Name.Add("Melin");
            Name.Add("Stephen");

            Params.Add(1);
            Params.Add(2);
            Params.Add(3);
            Params.Add(4);
        }
        
        public double Unit { get; set; }
        public double Mark { get; set; }
        public double Average { get; set; }
        public IList<string> name = new List<string>();
        public IList<string> Name 
        { 
            get
            {
                return name;
            }
            set
            {
                name=value;
            }
        }
        
        private IList<int> m_ID = new List<int>();
        public IList<int> Params
        {
            get { return m_ID; }
            set { m_ID = value; }
        }
    }

    public class ComboStringEditor : ITypeEditor
    {
        ComboBox combo;
        public void Attach(PropertyViewItem property, PropertyItem info)
        {
            var binding = new Binding("Value")
            {
                Mode = BindingMode.TwoWay,
                Source = info,
                ValidatesOnExceptions = true,
                ValidatesOnDataErrors = true
            };
            BindingOperations.SetBinding(combo, ComboBox.SelectedItemProperty, binding);
        }

        public object Create(PropertyInfo propertyInfo)
        {
            combo = new ComboBox();
            Style style = new Style { TargetType = typeof(ComboBox) };
            Setter setter = new Setter();
            setter.Property = ComboBox.IsEditableProperty;
            setter.Value = true;

            style.Setters.Add(setter);

            combo.Style = style;
            if (propertyInfo.Name == "Name")
            {
                Details det = new CustomPropertyEditor.Details();
                for (int i = 0; i < det.Name.Count; i++)
                {
                    combo.Items.Add(det.Name[i]);
                }
                combo.SelectedIndex = 0;
            }
            return combo;
        }

        public void Detach(PropertyViewItem property)
        {
            throw new NotImplementedException();
        }
    }

    public class ComboEditor : ITypeEditor
    {
        ComboBox combo;
        public void Attach(PropertyViewItem property, PropertyItem info)
        {
            var binding = new Binding("Value")
            {
                Mode = BindingMode.TwoWay,
                Source = info,
                ValidatesOnExceptions = true,
                ValidatesOnDataErrors = true
            };
            BindingOperations.SetBinding(combo, ComboBox.SelectedItemProperty, binding);
        }

        public object Create(PropertyInfo propertyInfo)
        {
            combo = new ComboBox();
            Style style = new Style { TargetType = typeof(ComboBox) };
            Setter setter = new Setter();
            setter.Property = ComboBox.IsEditableProperty;
            setter.Value = true;

            style.Setters.Add(setter);

            combo.Style = style;
            if (propertyInfo.Name == "Params")
            {
                Details det = new CustomPropertyEditor.Details();
                for (int i = 0; i < det.Params.Count; i++)
                {
                    combo.Items.Add(det.Params[i]);
                }
                combo.SelectedIndex = 0;
            }
            return combo;
        }

        public void Detach(PropertyViewItem property)
        {
            throw new NotImplementedException();
        }
    }
}
